<?php

if (IN_serendipity !== true) {
    die ("Don't hack!");
}


// Probe for a language include with constants. Still include defines later on, if some constants were missing
$probelang = dirname(__FILE__) . '/' . $serendipity['charset'] . 'lang_' . $serendipity['lang'] . '.inc.php';
if (file_exists($probelang)) {
    include $probelang;
}

include dirname(__FILE__) . '/lang_en.inc.php';

class serendipity_event_pubsubhubbub extends serendipity_event {
    var $title = PLUGIN_EVENT_PUBSUBHUBBUB_NAME;

    function introspect(&$propbag) {
        global $serendipity;

        $propbag->add('name',          PLUGIN_EVENT_PUBSUBHUBBUB_NAME);
        $propbag->add('description',   PLUGIN_EVENT_PUBSUBHUBBUB_DESC);
        $propbag->add('stackable',     false);
        $propbag->add('author',        'Malte Paskuda');
        $propbag->add('version',       '0.1');
        $propbag->add('requirements',  array(
            'serendipity' => '0.8'
        ));
        $propbag->add('event_hooks',   array('frontend_display:rss-2.0:namespace' => true,
                                             'frontend_display:atom-1.0:namespace' => true,
                                             'backend_publish' => true
                                             ));
        $propbag->add('groups', array('MARKUP'));
    }

    function generate_content(&$title) {
        $title = $this->title;
    }


    /*function introspect_config_item($name, &$propbag) {
        
    }*/


    function event_hook($event, &$bag, &$eventData, &$addData) {
        global $serendipity;
        $hooks = &$bag->get('event_hooks');

        if (isset($hooks[$event])) {
            switch($event) {
                case 'backend_publish':
                    global $serendipity;
                    include_once dirname(__FILE__) . '/publisher.php';
                    
                    $hub_url = 'http://pubsubhubbub.appspot.com/';
                    $topic_url = array();

                    //substring-operation to remove trailing /
                    $topic_url[] =  $serendipity['baseURL'] . 'rss.php?version=2.0';
                    $topic_url[] = $serendipity['baseURL']. 'rss.php?version=atom1.0';
                    
                    foreach($eventData['categories'] as $category) {
                        #entries without a category don't belong to a category-feed
                        if ($category > 0) {
                            $topic_url[] = substr($serendipity['baseURL'], 0, -1) . serendipity_feedCategoryURL($category, 'serendipityHTTPPath');
                        }
                    }
                    $p = new Publisher($hub_url);
                    if (! $p->publish_update($topic_url)) {
                        echo "Publishing to hub failed!";
                        print_r($p->last_response());
                    }
                    
                    return true;
                    break;
                case 'frontend_display:rss-2.0:namespace':
                    $eventData['channel_dat'] .= '<atom:link rel="hub" href="http://pubsubhubbub.appspot.com/" xmlns:atom="http://www.w3.org/2005/Atom" />';
                    
                    return true;
                    break;
                case 'frontend_display:atom-1.0:namespace':
                    $eventData['channel_dat'] .= '<link rel="hub" href="http://pubsubhubbub.appspot.com/" />';
                    
                    return true;
                    break;

                default:
                    return false;
            }
        } else {
            return false;
        }
    }

    function debugMsg($msg) {
        global $serendipity;
        
        $this->debug_fp = @fopen ( $serendipity ['serendipityPath'] . 'templates_c/pubsubhubbub.log', 'a' );
        if (! $this->debug_fp) {
            return false;
        }
        
        if (empty ( $msg )) {
            fwrite ( $this->debug_fp, "failure \n" );
        } else {
            fwrite ( $this->debug_fp, print_r ( $msg, true ) );
        }
        fclose ( $this->debug_fp );
    }

}

/* vim: set sts=4 ts=4 expandtab : */
?>
